//------------------------------------------------------------------------------
//
// File:    Base.h
//
// Purpose: Base class for graph library
//   
// (c) 2004 Plekhanov Andrey
//
// Initial version 1.0 30.04.2004
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//------------------------------------------------------------------------------

#ifndef __APSGraph__Base_h__
#define __APSGraph__Base_h__ 1

#include <iostream>

namespace aps {

  namespace apsgraph {

class Base
{
  private:

    unsigned int Flags;

  public:

    Base( void ) : Flags( 0 ) {}

    virtual ~Base( void ) {}

    unsigned int getFlags( void ) const
      { return( Flags ); }

    void setFlags( const unsigned int uMask )
      { Flags |= uMask; }

    void resetFlags( const unsigned int uMask )
      { Flags &= ~uMask; }

    void clearFlags( void )
      { Flags = 0; }

    virtual std::ostream & Print( std::ostream & s, const int Mod ) const = 0;
};

}}

#endif

//---------------------------- End of file ---------------------------
