//------------------------------------------------------------------------------
//
// File:    GraphElem.h
//
// Purpose: Graph element class for graph library
//   
// (c) 2004 Plekhanov Andrey
//
// Initial version 1.0 30.04.2004
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//------------------------------------------------------------------------------

#ifndef __APSGraph__Elem_h__
#define __APSGraph__Elem_h__ 1

#include "Base.h"

namespace aps {

  namespace apsgraph {

class GraphElem : public Base
{
  private:

    int tmpFlag;

  protected:

    GraphElem( void ) : Base(), tmpFlag( 0 ) {}

  public:

    int getTmpFlag( void ) const
      { return( tmpFlag ); }

    void setTmpFlag( const int aFlag )
      { tmpFlag = aFlag; }

    void clearTmpFlag( void )
      { tmpFlag = 0; }

    virtual int check( void ) const = 0;
};

}}

#endif

//---------------------------- End of file ---------------------------
