#include "gltest.h"

namespace aps {

std::ostream & testUVertex :: Print( std::ostream & s, const int Mod ) const
{
  s << "Test vertex = " << number << " ";

  apsgraph::UVertex<testUEdge,testUVertex> :: Print( s, Mod );

  return( s );
}

std::ostream & testUEdge :: Print( std::ostream & s, const int Mod ) const
{
  s << "TestEdge = " << weight << " ";

  apsgraph::UEdge<testUEdge,testUVertex> :: Print( s, Mod );

  return( s );
}

testUVertex * testUGraph :: createTestVertex( const int number )
{
  testUVertex * vertex;

  vertex = new testUVertex( number );

  addVertex( vertex );

  return( vertex );
}

testUEdge * testUGraph :: createTestEdge( testUVertex * vertex1, testUVertex * vertex2, const double weight )
{
  testUEdge * edge;

  edge = new testUEdge( vertex1, vertex2, weight );

  addEdge( edge );

  return( edge );
}


std::ostream & testDVertex :: Print( std::ostream & s, const int Mod ) const
{
  s << "Test vertex = " << number << " ";

  apsgraph::DVertex<testDEdge,testDVertex> :: Print( s, Mod );

  return( s );
}

std::ostream & testDEdge :: Print( std::ostream & s, const int Mod ) const
{
  s << "TestEdge = " << weight << " ";

  apsgraph::DEdge<testDEdge,testDVertex> :: Print( s, Mod );

  return( s );
}

testDVertex * testDGraph :: createTestVertex( const int number )
{
  testDVertex * vertex;

  vertex = new testDVertex( number );

  addVertex( vertex );

  return( vertex );
}

testDEdge * testDGraph :: createTestEdge( testDVertex * vertex1, testDVertex * vertex2, const int weight )
{
  testDEdge * edge;

  edge = new testDEdge( vertex1, vertex2, weight );

  addEdge( edge );

  return( edge );
}

}

int main( void )
{
  using namespace aps;

/*  testUGraph  * graph;
  testUVertex * vertex0;
  testUVertex * vertex1;
  testUVertex * vertex2;
  testUVertex * vertex3;
  testUVertex * vertex4;
  testUVertex * vertex5;
  testUVertex * vertex6;

  testUEdge   * edge1;

  std::list<apsgraph::GraphElem *> coll;

  graph = new testUGraph();

  vertex0 = graph->createTestVertex( 0 );
  vertex1 = graph->createTestVertex( 1 );
  vertex2 = graph->createTestVertex( 2 );
  vertex3 = graph->createTestVertex( 3 );
  vertex4 = graph->createTestVertex( 4 );
  vertex5 = graph->createTestVertex( 5 );
  vertex6 = graph->createTestVertex( 6 );

  graph->createTestEdge( vertex0, vertex1, 1.2 );
  graph->createTestEdge( vertex0, vertex2, 1.4 );
  graph->createTestEdge( vertex0, vertex5, 1.0 );
  graph->createTestEdge( vertex0, vertex6, 0.6 );
  edge1 = graph->createTestEdge( vertex1, vertex2, 1.4 );
  graph->createTestEdge( vertex2, vertex3, 1.1 );
  graph->createTestEdge( vertex2, vertex4, 1.8 );
  graph->createTestEdge( vertex3, vertex4, 2.5 );
  graph->createTestEdge( vertex4, vertex5, 1.3 );
  graph->createTestEdge( vertex4, vertex6, 3.2 );

  edge1->swapVerticies();

  printf("Check graph: %d\n", graph->checkGraph() );

  //graph->Print( 0 );

  graph->removeEdge( edge1 );

  //graph->Print( 0 );

  graph->removeVertex( vertex0 );

  //graph->Print( 0 );

  printf("Check graph: %d\n", graph->checkGraph() );

  printf("Find path between 0 and 4 = %d\n", graph->findPath( vertex0, vertex4 ) );

  testUVertex * vertexTmp = graph->createTestVertex( 100 );

  printf("Find path between 0 and 100 = %d\n", graph->findPath( vertex0, vertexTmp ) );  

  graph->removeVertex( vertexTmp );

  printf("Check graph: %d\n", graph->checkGraph() );

  printf("Find hamilton path between 0 and 5 = %d\n", graph->findHamiltonPath( vertex0, vertex5, coll ) );

  testUEdge * edge2 = graph->createTestEdge( vertex1, vertex3, 1.5 );
  testUEdge * edge3 = graph->createTestEdge( vertex3, vertex5, 1.7 );

  //graph->Print( 0 );

  printf("Find hamilton path between 0 and 5 = %d\n", graph->findHamiltonPath( vertex0, vertex5, coll ) );

  graph->removeEdge( edge2 );
  graph->removeEdge( edge3 );

  graph->Print( std::cout, 0 );

  printf("Check graph: %d\n", graph->checkGraph() );

  graph->Print( std::cout, 1 );

  delete graph;*/


  {
  std::cout << "FindAllCycles" << std::endl;

  testDGraph  *  graph = new testDGraph();

  testDVertex * vertex0 = graph->createTestVertex( 0 );
  testDVertex * vertex1 = graph->createTestVertex( 1 );
  testDVertex * vertex2 = graph->createTestVertex( 2 );
  testDVertex * vertex3 = graph->createTestVertex( 3 );
  testDVertex * vertex4 = graph->createTestVertex( 4 );
  testDVertex * vertex5 = graph->createTestVertex( 5 );
  testDVertex * vertex6 = graph->createTestVertex( 6 );
  testDVertex * vertex7 = graph->createTestVertex( 7 );
  testDVertex * vertex8 = graph->createTestVertex( 8 );
  testDVertex * vertex9 = graph->createTestVertex( 9 );
  testDVertex * vertex10 = graph->createTestVertex( 10 );
  testDVertex * vertex11 = graph->createTestVertex( 11 );
  testDVertex * vertex12 = graph->createTestVertex( 12 );

  graph->createTestEdge( vertex4, vertex2, 1 );
  graph->createTestEdge( vertex2, vertex3, 2 );
  graph->createTestEdge( vertex3, vertex2, 3 );
  graph->createTestEdge( vertex0, vertex6, 4 );
  graph->createTestEdge( vertex0, vertex1, 5 );
  graph->createTestEdge( vertex2, vertex0, 6 );
  graph->createTestEdge( vertex11, vertex12, 7 );
  graph->createTestEdge( vertex12, vertex9, 8 );
  graph->createTestEdge( vertex9, vertex10, 9 );
  graph->createTestEdge( vertex9, vertex11, 10 );
  graph->createTestEdge( vertex8, vertex9, 11 );
  graph->createTestEdge( vertex10, vertex12, 12 );
  graph->createTestEdge( vertex4, vertex11, 13 );
  graph->createTestEdge( vertex4, vertex3, 14 );
  graph->createTestEdge( vertex3, vertex5, 15 );
  graph->createTestEdge( vertex7, vertex8, 16 );
  graph->createTestEdge( vertex8, vertex7, 17 );
  graph->createTestEdge( vertex5, vertex4, 18 );
  graph->createTestEdge( vertex0, vertex5, 19 );
  graph->createTestEdge( vertex6, vertex4, 20 );
  graph->createTestEdge( vertex6, vertex9, 21 );
  graph->createTestEdge( vertex7, vertex6, 22 );

  std::list<std::list<apsgraph::GraphElem*> > Cycles;

  int CyclesNumber = graph->FindAllCycles( Cycles );

  std::cout << "CyclesNumber = " << CyclesNumber << std::endl;

  for( std::list<std::list<apsgraph::GraphElem*> >::const_iterator i = Cycles.begin();
       i != Cycles.end(); ++i ) {       
    std::list<apsgraph::GraphElem*> list = *i;

    std::cout << std::endl;

    for( std::list<apsgraph::GraphElem*>::const_iterator j = list.begin();
         j != list.end(); ++j ) {
      apsgraph::GraphElem * e = *j;

      e->Print( std::cout, 0 );
    }
  }

  /*printf("Check graph: %d\n", graph->checkGraph() );

  graph->Print( std::cout, 1 );

  graph->removeEdge( edge );
  graph->removeVertex( vertex2 );

  printf("Check graph: %d\n", graph->checkGraph() );

  graph->Print( std::cout, 1 );

  printf("Find path between 0 and 4 = %d\n", graph->findPath( vertex0, vertex4 ) );

  testDVertex * vertexTmp = graph->createTestVertex( 100 );

  printf("Find path between 0 and 100 = %d\n", graph->findPath( vertex0, vertexTmp ) );  

  graph->removeVertex( vertexTmp );*/

  delete graph;

  std::cout << std::endl;
  }

//================================= findHamiltonCycle =================================

  {
  // Icosahedron

  std::cout << "findHamiltonCycle Icosahedron" << std::endl;

  std::list<apsgraph::GraphElem *> coll;

  testUGraph * graph = new testUGraph();

  testUVertex * vertex1 = graph->createTestVertex( 1 );
  testUVertex * vertex2 = graph->createTestVertex( 2 );
  testUVertex * vertex3 = graph->createTestVertex( 3 );
  testUVertex * vertex4 = graph->createTestVertex( 4 );
  testUVertex * vertex5 = graph->createTestVertex( 5 );
  testUVertex * vertex6 = graph->createTestVertex( 6 );
  testUVertex * vertex7 = graph->createTestVertex( 7 );
  testUVertex * vertex8 = graph->createTestVertex( 8 );
  testUVertex * vertex9 = graph->createTestVertex( 9 );
  testUVertex * vertex10 = graph->createTestVertex( 10 );
  testUVertex * vertex11 = graph->createTestVertex( 11 );
  testUVertex * vertex12 = graph->createTestVertex( 12 );

  graph->createTestEdge( vertex1, vertex2, 1.1 );
  graph->createTestEdge( vertex1, vertex3, 1.2 );
  graph->createTestEdge( vertex1, vertex4, 1.3 );
  graph->createTestEdge( vertex1, vertex7, 1.4 );
  graph->createTestEdge( vertex1, vertex12, 1.5 );
  graph->createTestEdge( vertex2, vertex3, 1.6 );
  graph->createTestEdge( vertex2, vertex5, 1.7 );
  graph->createTestEdge( vertex2, vertex10, 1.8 );
  graph->createTestEdge( vertex2, vertex12, 1.9 );
  graph->createTestEdge( vertex12, vertex10, 2.0 );
  graph->createTestEdge( vertex12, vertex11, 2.1 );
  graph->createTestEdge( vertex12, vertex7, 2.2 );
  graph->createTestEdge( vertex3, vertex4, 2.3 );
  graph->createTestEdge( vertex3, vertex6, 2.4 );
  graph->createTestEdge( vertex3, vertex5, 2.5 );
  graph->createTestEdge( vertex4, vertex7, 2.6 );
  graph->createTestEdge( vertex4, vertex8, 2.7 );
  graph->createTestEdge( vertex4, vertex6, 2.8 );
  graph->createTestEdge( vertex6, vertex8, 2.9 );
  graph->createTestEdge( vertex6, vertex9, 3.0 );
  graph->createTestEdge( vertex6, vertex5, 3.1 );
  graph->createTestEdge( vertex5, vertex9, 3.2 );
  graph->createTestEdge( vertex5, vertex10, 3.3 );
  graph->createTestEdge( vertex7, vertex11, 3.4 );
  graph->createTestEdge( vertex7, vertex8, 3.5 );
  graph->createTestEdge( vertex8, vertex11, 3.6 );
  graph->createTestEdge( vertex8, vertex9, 3.7 );
  graph->createTestEdge( vertex9, vertex11, 3.8 );
  graph->createTestEdge( vertex9, vertex10, 3.9 );
  graph->createTestEdge( vertex10, vertex11, 4.0 );

  bool find = graph->findHamiltonCycle( coll );

  std::cout << "Find = " << find << std::endl;

  if( find ) {
    for( std::list<apsgraph::GraphElem*>::const_iterator i = coll.begin();
         i != coll.end(); ++i ) {
      apsgraph::GraphElem * elem = *i;

      elem->Print( std::cout, 0 );
    }
  }

  delete graph;

  std::cout << std::endl;
  }

  {
  // Dodecahedron

  std::cout << "findHamiltonCycle Dodecahedron" << std::endl;

  std::list<apsgraph::GraphElem *> coll;

  testUGraph * graph = new testUGraph();

  testUVertex * vertex1 = graph->createTestVertex( 1 );
  testUVertex * vertex2 = graph->createTestVertex( 2 );
  testUVertex * vertex3 = graph->createTestVertex( 3 );
  testUVertex * vertex4 = graph->createTestVertex( 4 );
  testUVertex * vertex5 = graph->createTestVertex( 5 );
  testUVertex * vertex6 = graph->createTestVertex( 6 );
  testUVertex * vertex7 = graph->createTestVertex( 7 );
  testUVertex * vertex8 = graph->createTestVertex( 8 );
  testUVertex * vertex9 = graph->createTestVertex( 9 );
  testUVertex * vertex10 = graph->createTestVertex( 10 );
  testUVertex * vertex11 = graph->createTestVertex( 11 );
  testUVertex * vertex12 = graph->createTestVertex( 12 );
  testUVertex * vertex13 = graph->createTestVertex( 13 );
  testUVertex * vertex14 = graph->createTestVertex( 14 );
  testUVertex * vertex15 = graph->createTestVertex( 15 );
  testUVertex * vertex16 = graph->createTestVertex( 16 );
  testUVertex * vertex17 = graph->createTestVertex( 17 );
  testUVertex * vertex18 = graph->createTestVertex( 18 );
  testUVertex * vertex19 = graph->createTestVertex( 19 );
  testUVertex * vertex20 = graph->createTestVertex( 20 );

  graph->createTestEdge( vertex1, vertex2, 1.1 );
  graph->createTestEdge( vertex1, vertex3, 1.2 );
  graph->createTestEdge( vertex1, vertex15, 1.3 );
  graph->createTestEdge( vertex2, vertex5, 1.4 );
  graph->createTestEdge( vertex2, vertex16, 1.5 );
  graph->createTestEdge( vertex3, vertex7, 1.6 );
  graph->createTestEdge( vertex3, vertex4, 1.7 );
  graph->createTestEdge( vertex4, vertex6, 1.8 );
  graph->createTestEdge( vertex4, vertex5, 1.9 );
  graph->createTestEdge( vertex5, vertex10, 2.0 );
  graph->createTestEdge( vertex6, vertex8, 2.1 );
  graph->createTestEdge( vertex6, vertex9, 2.2 );
  graph->createTestEdge( vertex7, vertex11, 2.3 );
  graph->createTestEdge( vertex7, vertex8, 2.4 );
  graph->createTestEdge( vertex8, vertex12, 2.5 );
  graph->createTestEdge( vertex9, vertex13, 2.6 );
  graph->createTestEdge( vertex9, vertex10, 2.7 );
  graph->createTestEdge( vertex10, vertex14, 2.8 );
  graph->createTestEdge( vertex11, vertex15, 2.9 );
  graph->createTestEdge( vertex11, vertex17, 3.0 );
  graph->createTestEdge( vertex12, vertex17, 3.1 );
  graph->createTestEdge( vertex12, vertex13, 3.2 );
  graph->createTestEdge( vertex13, vertex18, 3.3 );
  graph->createTestEdge( vertex14, vertex18, 3.4 );
  graph->createTestEdge( vertex14, vertex16, 3.5 );
  graph->createTestEdge( vertex15, vertex20, 3.6 );
  graph->createTestEdge( vertex16, vertex20, 3.7 );
  graph->createTestEdge( vertex17, vertex19, 3.8 );
  graph->createTestEdge( vertex18, vertex19, 3.9 );
  graph->createTestEdge( vertex19, vertex20, 4.0 );

  bool find = graph->findHamiltonCycle( coll );

  std::cout << "Find = " << find << std::endl;

  if( find ) {
    for( std::list<apsgraph::GraphElem*>::const_iterator i = coll.begin();
         i != coll.end(); ++i ) {
      apsgraph::GraphElem * elem = *i;

      elem->Print( std::cout, 0 );
    }
  }

  delete graph;

  std::cout << std::endl;
  }

  {
  // Find components

  std::cout << "Find components" << std::endl;

  std::list<apsgraph::GraphElem *> coll;

  testUGraph * graph = new testUGraph();

  testUVertex * vertex1 = graph->createTestVertex( 1 );
  testUVertex * vertex2 = graph->createTestVertex( 2 );
  testUVertex * vertex3 = graph->createTestVertex( 3 );
  graph->createTestVertex( 4 );

  graph->createTestEdge( vertex1, vertex2, 1.1 );
  graph->createTestEdge( vertex1, vertex3, 1.2 );

  int components = graph->findComponents();

  std::cout << "Components = " << components << std::endl;

  delete graph;

  std::cout << std::endl;
  }

  {
  // Euler path

  std::cout << "Find Euler path" << std::endl;

  std::list<testUVertex *> coll;

  testUGraph * graph = new testUGraph();

  testUVertex * vertex0 = graph->createTestVertex( 0 );
  testUVertex * vertex1 = graph->createTestVertex( 1 );
  testUVertex * vertex2 = graph->createTestVertex( 2 );
  testUVertex * vertex3 = graph->createTestVertex( 3 );
  testUVertex * vertex4 = graph->createTestVertex( 4 );
  testUVertex * vertex5 = graph->createTestVertex( 5 );
  testUVertex * vertex6 = graph->createTestVertex( 6 );

  graph->createTestEdge( vertex0, vertex5, 1.1 );
  graph->createTestEdge( vertex0, vertex1, 1.1 );
  graph->createTestEdge( vertex0, vertex2, 1.1 );
  graph->createTestEdge( vertex0, vertex6, 1.1 );
  graph->createTestEdge( vertex1, vertex2, 1.1 );
  graph->createTestEdge( vertex2, vertex3, 1.1 );
  graph->createTestEdge( vertex2, vertex4, 1.1 );
  graph->createTestEdge( vertex3, vertex4, 1.1 );
  graph->createTestEdge( vertex4, vertex5, 1.1 );
  graph->createTestEdge( vertex4, vertex6, 1.1 );

  bool exists = graph->findEulerPath( vertex0, vertex0, coll );

  if( exists ) {
    std::cout << "Euler path = " << std::endl;

    for( std::list<testUVertex*>::const_iterator i = coll.begin();
         i != coll.end(); ++i ) {
      testUVertex * vertex = *i;

      vertex->Print( std::cout, 0 );
    }
  }
  else {
    std::cout << "Euler path doesn't exists." << std::endl;
  }

  delete graph;

  std::cout << std::endl;
  }

  return( 0 );
}

//---------------------------- End of file ---------------------------


