#ifndef __APSGraph__test_h__
#define __APSGraph__test_h__ 1

#include "UEdge.h"
#include "UVertex.h"
#include "UGraph.h"

#include "DEdge.h"
#include "DVertex.h"
#include "DGraph.h"

#include <list>

namespace aps {

class testUEdge;
class testUVertex;

class testUVertex : public apsgraph::UVertex<testUEdge,testUVertex>
{
  friend class apsgraph::Graph<testUEdge,testUVertex>;
  friend class testUGraph;

  private:

    int number;

    testUVertex( int aNumber ) : apsgraph::UVertex<testUEdge,testUVertex>(), number( aNumber ) {}

    virtual ~testUVertex( void ) {}

  public:

    virtual std::ostream & Print( std::ostream & s, const int Mod ) const;
};

class testUEdge : public apsgraph::UEdge<testUEdge,testUVertex>
{
  friend class apsgraph::Graph<testUEdge,testUVertex>;
  friend class testUGraph;

  private:

    double weight;

    testUEdge( testUVertex * vertex1, testUVertex * vertex2, double aWeight ) :
               apsgraph::UEdge<testUEdge,testUVertex>( vertex1, vertex2 ), weight( aWeight ) {}

    virtual ~testUEdge( void ) {}

  public:

    virtual std::ostream & Print( std::ostream & s, const int Mod ) const;
};

class testUGraph : public apsgraph::UGraph<testUEdge,testUVertex>
{
  public:

    testUGraph( void ) : apsgraph::UGraph<testUEdge,testUVertex>() {}

    virtual ~testUGraph( void ) {}

    testUVertex * createTestVertex( int number );

    testUEdge * createTestEdge( testUVertex * vertex1, testUVertex * vertex2, double weight );
};

class testDEdge;
class testDVertex;

class testDVertex : public apsgraph::DVertex<testDEdge,testDVertex>
{
  friend class apsgraph::Graph<testDEdge,testDVertex>;
  friend class testDGraph;

  private:

    int number;

    testDVertex( const int aNumber ) : apsgraph::DVertex<testDEdge,testDVertex>(), number( aNumber ) {}

    virtual ~testDVertex( void ) {}

  public:

    virtual std::ostream & Print( std::ostream & s, const int Mod ) const;
};

class testDEdge : public apsgraph::DEdge<testDEdge,testDVertex>
{
  friend class apsgraph::Graph<testDEdge,testDVertex>;
  friend class testDGraph;

  private:

    int weight;

    testDEdge( testDVertex * vertex1, testDVertex * vertex2, const int aWeight ) :
               apsgraph::DEdge<testDEdge,testDVertex>( vertex1, vertex2 ), weight( aWeight ) {}

    virtual ~testDEdge( void ) {}

  public:

    virtual std::ostream & Print( std::ostream & s, const int Mod ) const;
};

class testDGraph : public apsgraph::DGraph<testDEdge,testDVertex>
{
  public:

    testDGraph( void ) : apsgraph::DGraph<testDEdge,testDVertex>() {}

    virtual ~testDGraph( void ) {}

    testDVertex * createTestVertex( int number );

    testDEdge * createTestEdge( testDVertex * vertex1, testDVertex * vertex2, const int weight );
};

}

#endif

//---------------------------- End of file ---------------------------
