//------------------------------------------------------------------------------
//
// File:    UVertex.h
//
// Purpose: Undirected vertex class for graph library
//   
// (c) 2004 Plekhanov Andrey
//
// Initial version 1.0 30.04.2004
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//------------------------------------------------------------------------------

#ifndef __APSGraph__UVertex_h__
#define __APSGraph__UVertex_h__ 1

#include "Vertex.h"

namespace aps {

  namespace apsgraph {

template <class TEdge,class TVertex>
class UVertex : public Vertex<TEdge,TVertex>
{
  template <class,class> friend class UGraph;

  private:

    TEdge   * firstEdge;
    TEdge   * lastEdge;

    virtual void addEdge1( TEdge * edge );

    virtual void addEdge2( TEdge * edge );

    virtual void removeEdge( TEdge * edge );

    virtual void clearAllEdges( void );

  protected:

    UVertex( void ) : Vertex<TEdge,TVertex>(), firstEdge( 0 ), lastEdge( 0 ) {}

  public:

    TEdge * getFirstUEdge( void ) const
      { return( firstEdge ); }

    TEdge * getLastUEdge( void ) const
      { return( lastEdge ); }

    int getEdgesCount( void ) const;

    int IfEdgeInVertex( TEdge * edge ) const;

    virtual int check( void ) const;

    virtual std::ostream & Print( std::ostream & s, const int Mod ) const;
};

}}

#include "UVertex_impl.h"

#endif

//---------------------------- End of file ---------------------------
