//------------------------------------------------------------------------------
//
// File:    Vertex.h
//
// Purpose: Vertex class for graph library
//   
// (c) 2004 Plekhanov Andrey
//
// Initial version 1.0 30.04.2004
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//------------------------------------------------------------------------------

#ifndef __APSGraph__Vertex_h__
#define __APSGraph__Vertex_h__ 1

#include "GraphElem.h"

namespace aps {

  namespace apsgraph {

template <class TEdge,class TVertex>
class Vertex : public GraphElem
{
  template <class,class> friend class Graph;

  private:

    TVertex * next;
    TVertex * prev;
    int       visited;

  protected:

    Vertex( void ) : GraphElem(), next( 0 ), prev( 0 ), visited( 0 ) {}

  public:

    TVertex * getNext( void ) const
      { return( next ); }

    TVertex * getPrev( void ) const
      { return( prev ); }

    int getVisit( void ) const
      { return( visited ); }

    void setVisit( const int aVisited )
      { visited = aVisited; }

    void clearVisit( void )
      { visited = 0; }
};

}}

#endif

//---------------------------- End of file ---------------------------
